﻿Imports System.Globalization

Namespace Converter
    Public Class KilobyteToNiceStringConverter
        Implements IValueConverter

        Public Function Convert(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.Convert
            Dim val As Double = CDbl(value)
            Return FormatBytes(val)
        End Function

        Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
            Throw New NotImplementedException()
        End Function

        Public Function FormatBytes(kilobyte As Double) As String
            Try
                Select Case kilobyte
                    Case Is >= 1099511627
                        kilobyte = CDbl(kilobyte / 1099511627)
                        Return FormatNumber(kilobyte, 2) & " TB"
                    Case 1073741 To 1099511627
                        kilobyte = CDbl(kilobyte / 1073741)
                        Return FormatNumber(kilobyte, 2) & " GB"
                    Case 1048576 To 1073741
                        kilobyte = CDbl(kilobyte / 1048)
                        Return FormatNumber(kilobyte, 2) & " MB"
                    Case 1 To 1048
                        Return FormatNumber(kilobyte, 2) & " KB"
                    Case Else
                        Return "Error"
                End Select
            Catch
                Return ""
            End Try

        End Function


    End Class
End Namespace